package org.openjdk.gcbench.tests;

import org.openjdk.jmh.annotations.*;
import org.openjdk.jmh.infra.Blackhole;


@Fork(jvmArgsPrepend = {"--add-opens", "java.base/jdk.internal.misc=ALL-UNNAMED"})
@State(Scope.Benchmark)
public class UnderPressureTest {

    SuperAllocator allocator;

    @Setup
    public void setup(Blackhole bh) {
        allocator = new SuperAllocator(bh);
        allocator.start();
    }

    @TearDown
    public void tearDown() throws InterruptedException {
        allocator.interrupt();
        allocator.join();
    }

    public class SuperAllocator extends Thread {
        private final Blackhole bh;

        public SuperAllocator(Blackhole bh) {
            this.bh = bh;
        }

        @Override
        public void run() {
            while (!Thread.interrupted()) {
                bh.consume(AllocUninit.alloc(1000));
            }
        }
    }

}
